; ++++++++ Extra Controls Lib ++++++++++
; ++++++Programmed by Luis Costa +++++++
; +++++++++ Lisbon, Portugal +++++++++++
; +++++ contact:XANDAZ@HOTMAIL:COM +++++

__UNICODE__ equ 1

.586p
.model flat,stdcall
option casemap:none
.xmm
.mmx

RegisterControls    PROTO   :DWORD,:DWORD
StaticExProc        PROTO   :DWORD,:DWORD,:DWORD,:DWORD
DrawChev            PROTO   :DWORD

include c:\masm32\include\windows.inc
include c:\masm32\include\kernel32.inc
include c:\masm32\include\user32.inc
include c:\masm32\include\gdi32.inc
include .\ecl.inc

include c:\masm32\macros\macros.asm

includelib c:\masm32\lib\kernel32.lib
includelib c:\masm32\lib\user32.lib
includelib c:\masm32\lib\gdi32.lib

.const

.data
UCSTR       StaticExClass,"STATICEX",0   
wcStaticEx  WNDCLASS    <CS_HREDRAW+CS_VREDRAW,offset StaticExProc,0,\
                        sizeof EXTRA,0,0,0,COLOR_WINDOW,0,\
                        offset StaticExClass>
; +++ Sub-Controls +++

UCSTR       ChevronClass,"CHEVRON",0
wcChevron   WNDCLASS    <CS_HREDRAW+CS_VREDRAW,offset ChevronProc,0,\
                        sizeof EXTRA,0,0,0,COLOR_WINDOW,0,offset ChevronClass>
stxnsc  NM_STXHEIGHTCHANGED     <>

.code
invoke  StaticExProc,0,0,0,0
RegisterControls    PROC    hInstance:DWORD,dwControls:DWORD
    .if     dwControls&&IEC_STATIC_CLASS
        push    hInstance
        pop     wcStaticEx.hInstance
        sub     esp,4
        pop     wcChevron.hInstance
        invoke  RegisterClass,addr wcStaticEx
        invoke  RegisterClass,addr wcChevron
    .endif
    ret

RegisterControls    endp

StaticExProc    PROC    uses esi edi hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    local   chX:DWORD,ChY:DWORD
    
    .if     uMsg==WM_CREATE
        invoke  LocalAlloc,LPTR,sizeof STEXSTRUCT
        mov     edi,eax
        push    hWnd
        pop     [edi.STEXSTRUCT].hWnd
        push    eax
        invoke  SetWindowLong,hWnd,EXTRA.hMem,eax
        pop     edi
        sub     esp,4
        mov     esi,lParam
        assume  esi:PTR CREATESTRUCT
        mov     ecx,sizeof CREATESTRUCT/4
        assume  edi:PTR STEXSTRUCT
        cld
loop_1:
        movsd
        dec     ecx
        jcxz    end_loop_1
        jmp     loop_1
end_loop_1:
        pop     edi
        mov     esi,lParam
        invoke  GetClientRect,[esi].hWndParent,addr [edi].WndRect
        test    [esi].style,STXS_BOTTOM
        jp      align_wnd_to_bottom
        test    [esi].style,STXS_TOP
        jz      proceed_01            
        cmp     [esi].y,0
        ja      align_to_top
        jmp     proceed_01
align_to_top:
        invoke  MoveWindow,hWnd,0,0,[edi].WndRect.right,[esi].ly,TRUE
        jmp     proceed_01
align_wnd_to_bottom:
        mov     eax,[esi].ly
        sub     [edi].WndRect.bottom,eax
        invoke  MoveWindow,hWnd,0,[edi].WndRect.bottom,[edi].WndRect.right,[esi].ly,TRUE
        jmp     proceed_01
proceed_01:
        .if     [esi].lpszName!=0
            push    [esi].lpszName
            pop     [edi].acstr.lpText
            mov     [edi].dwAction,ACT_TEXT
            invoke  SendMessage,hWnd,STXM_ADDCONTENT,0,addr [edi].acstr
        .endif            
            push    [esi].x
            pop     [edi].rect.left
            sub     esp,4
            pop     [edi].ChevStruct.chX
            push    [esi].y
            pop     [edi].rect.top
            sub     esp,4
            test    [esi].style,STXS_BOTTOM
            jp      bottom_aligned
            pop     [edi].ChevStruct.chY
            add     [edi].ChevStruct.chY,2
            jmp     proceed_0
bottom_aligned:
            mov     eax,[esi].ly
            add     eax,[esi].y
            sub     eax,6
            mov     [edi].ChevStruct.chY,eax
proceed_0:
            push    [esi].lx
            pop     [edi].rect.right
            push    [esi].ly
            pop     [edi].rect.bottom
            add     [edi].ChevStruct.chX,2
            invoke  GetProcessHeap
            push    eax
            invoke  HeapAlloc,eax,HEAP_ZERO_MEMORY,sizeof CREATESTRUCTEX
            mov     ecx,eax
            mov     [ecx.CREATESTRUCTEX].hMem,eax
            pop     ebx
            mov     [ecx.CREATESTRUCTEX].hHeap,ebx
            push    hWnd
            pop     [ecx.CREATESTRUCTEX].hWndRef
            mov     eax,[esi].style
            invoke  CreateWindowEx,NULL,addr ChevronClass,0,WS_CHILD,\
                         [edi].ChevStruct.chX,[edi].ChevStruct.chY,7,4,\
                         [edi].cstr.hWndParent,0,[esi].hInstance,ecx
            mov     [edi].ChevStruct.hCh,eax

            assume  esi:NOTHING
            assume  edi:NOTHING
                                                      
    .elseif uMsg==STXM_ADDCONTENT
        mov     edi,lParam
        assume  edi:PTR ACSTRUCT
        invoke  GetWindowLong,hWnd,EXTRA.hMem
        mov     esi,eax
        assume  esi:PTR STEXSTRUCT
        .if     [edi].hIcon!=0
            or  eax,ACT_ICON
            push    [edi].hIcon
            pop     [esi].acstr.hIcon
        .else
            .if [edi].hBitmap!=0
                or      eax,ACT_BITMAP
                push    [edi].hBitmap
                pop     [esi].acstr.hBitmap
            .endif                
        .endif
        .if [edi].lpText!=0
            or  eax,ACT_TEXT
            push    [edi].lpText
            pop     [esi].acstr.lpText
        .endif
        or      eax,ACT_SHOW
        mov     [esi].dwAction,eax
        invoke  SendMessage,hWnd,WM_PAINT,0,0
        assume  esi:NOTHING
        
    .elseif uMsg==WM_PAINT
        invoke  GetWindowLong,hWnd,EXTRA.hMem
        mov     esi,eax
        assume  esi:PTR STEXSTRUCT
            test    [esi].dwAction,ACT_SHOW
            jz      hide_it
            invoke  SetTimer,hWnd,0100,2000,addr StaticExProc
            lea     edi,[esi].ps
            assume  edi:PTR PAINTSTRUCT
            invoke  BeginPaint,hWnd,edi
            invoke  CreateCompatibleDC,[edi].hdc
            mov     [esi].hMemDC,eax
            test    [esi].dwAction,ACT_ICON
            jz      no_icon
            invoke  DrawIconEx,[edi].hdc,[edi].rcPaint.left,[edi].rcPaint.top,[esi].acstr.hIcon,\
                        20,20,0,0,DI_NORMAL
            add     [edi].rcPaint.left,32
            jmp     test_4_text
no_icon:        
            test    [esi].dwAction,ACT_BITMAP
            jz      test_4_text
            invoke  SelectObject,[esi].hMemDC,[esi].acstr.hBitmap
            invoke  DeleteObject,eax
            invoke  GetBitmapDimensionEx,[esi].acstr.hBitmap,addr [esi]._size
            invoke  StretchBlt,[edi].hdc,[edi].rcPaint.top,[edi].rcPaint.top,20,20,\
                        [esi].hMemDC,0,0,[esi]._size.x,[esi]._size.y,SRCCOPY
            add     [edi].rcPaint.left,32                        
test_4_text:
            test    [esi].dwAction,ACT_TEXT
            jz      no_text
            test    [esi].dwAction,DEF_FONT
            jz      do_text
            invoke  SelectObject,[edi].hdc,[esi].hFont
            invoke  DeleteObject,eax
do_text:        
            invoke  SetBkMode,[edi].hdc,TRANSPARENT
            invoke  SetTextColor,[edi].hdc,0
            invoke  DrawText,[edi].hdc,[esi].acstr.lpText,-1,addr [edi].rcPaint,DT_LEFT
no_text:
            invoke  DeleteDC,[esi].hMemDC
            invoke  SetBkMode,[edi].hdc,OPAQUE
            invoke  EndPaint,hWnd,edi
            jmp     end_it
hide_it:    
            invoke  ShowWindow,hWnd,SW_HIDE
            invoke  ShowWindow,[esi].ChevStruct.hCh,SW_SHOW
            invoke  SendMessage,[esi].ChevStruct.hCh,WM_PAINT,0,0
            mov     stxnsc.Height,8
            mov     stxnsc.hdr.code,STXN_HEIGHTCHANGED
            invoke  SendMessage,[esi].cstr.hWndParent,WM_NOTIFY,0,addr stxnsc
end_it:            
            assume  edi:NOTHING      
            assume  esi:NOTHING 
        
    .elseif uMsg==WM_TIMER
    
        invoke  GetWindowLong,hWnd,EXTRA.hMem
        mov     esi,eax
        and     [esi.STEXSTRUCT].dwAction,NOT ACT_SHOW
        invoke  SendMessage,hWnd,WM_PAINT,0,0
        invoke  KillTimer,hWnd,0100
        
    .elseif uMsg==WM_SETFONT
        invoke  GetWindowLong,hWnd,EXTRA.hMem
        mov     edi,eax
        push    wParam
        pop     [edi.STEXSTRUCT].hFont
        or      [edi.STEXSTRUCT].dwAction,DEF_FONT
        .if     lParam==TRUE
            invoke  SendMessage,hWnd,WM_PAINT,0,0
        .endif            
   .elseif uMsg==WM_DESTROY
        invoke  GetWindowLong,hWnd,EXTRA.hMem
        invoke  LocalFree,eax
               
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    mov     eax,0
    ret        
        
StaticExProc    endp

ChevronProc     PROC   uses esi edi hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    
    .if     uMsg==WM_CREATE

        mov     edi,lParam
        mov     edi,[edi.CREATESTRUCT].lpCreateParams
        assume  edi:PTR CREATESTRUCTEX
        invoke  GetWindowLong,[edi].hWndRef,EXTRA.hMem
        mov     esi,eax
        assume  esi:PTR STEXSTRUCT
        invoke  SetWindowLong,hWnd,EXTRA.hMem,esi
        test    [edi].cstr.style,STXS_BOTTOM
        jp      bottom_aligned ; && NOT STXS_BOTTOM
        invoke  CreatePolygonRgn,addr [esi].ChevStruct.chPtsTop,4,ALTERNATE
        jmp     proceed_1
bottom_aligned:        
        invoke  CreatePolygonRgn,addr [esi].ChevStruct.chPtsBottom,4,ALTERNATE
proceed_1:        
        mov     [esi].ChevStruct.chRgn,eax
        invoke  GetDC,hWnd
        mov     [esi].hDC,eax
        invoke  SelectObject,[esi].hDC,[esi].ChevStruct.chRgn
        invoke  DeleteObject,eax
        invoke  ReleaseDC,hWnd,[esi].hDC
        invoke  HeapFree,[edi].hHeap,0,[edi].hMem
        
    .elseif uMsg==WM_PAINT

        invoke  GetWindowLong,hWnd,EXTRA.hMem
        mov     esi,eax
        assume  esi:PTR STEXSTRUCT
        invoke  BeginPaint,hWnd,addr [esi].ps
        test    [esi].cstr.style,STXS_BOTTOM
        jp      bottom_aligned_2 ;&& NOT STXS_BOTTOM
        invoke  DrawChev,TOP_ALIGN
        jmp     end_it        
bottom_aligned_2:        
        invoke  DrawChev,BOTTOM_ALIGN
end_it:        
        invoke  EndPaint,hWnd,addr [esi].ps

        assume  esi:NOTHING
        
    .elseif uMsg==WM_MOUSEMOVE
        invoke  GetWindowLong,hWnd,EXTRA.hMem
        mov     esi,eax
        assume  esi:PTR STEXSTRUCT
        invoke  ShowWindow,[esi].hWnd,SW_SHOW
        invoke  ShowWindow,hWnd,SW_HIDE
        invoke  SendMessage,[esi].hWnd,WM_PAINT,0,0
        or      [esi].dwAction,ACT_SHOW
        mov     stxnsc.hdr.code,STXN_HEIGHTCHANGED
        push    [esi].cstr.ly
        pop     stxnsc.Height
        invoke  SendMessage,[esi].cstr.hWndParent,WM_NOTIFY,0,addr stxnsc
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor     eax,eax        
    ret
    
ChevronProc     endp

DrawChev    PROC    DrawHow:DWORD

    assume  esi:PTR STEXSTRUCT
    
    .if     DrawHow==TOP_ALIGN
        invoke  MoveToEx,[esi].ps.hdc,0,0,0
        invoke  CreatePen,PS_SOLID,1,0ffffffh
        invoke  SelectObject,[esi].ps.hdc,eax
        invoke  DeleteObject,eax
        invoke  LineTo,[esi].ps.hdc,6,0
        invoke  LineTo,[esi].ps.hdc,3,3       
        invoke  CreatePen,PS_SOLID,1,0
        invoke  SelectObject,[esi].ps.hdc,eax
        invoke  DeleteObject,eax
        invoke  LineTo,[esi].ps.hdc,0,0 
     .elseif DrawHow==BOTTOM_ALIGN
        invoke  MoveToEx,[esi].ps.hdc,3,0,0
        invoke  CreatePen,PS_SOLID,1,0ffffffh
        invoke  SelectObject,[esi].ps.hdc,eax
        invoke  DeleteObject,eax
        invoke  LineTo,[esi].ps.hdc,6,3
        invoke  LineTo,[esi].ps.hdc,0,3
        invoke  CreatePen,PS_SOLID,1,0
        invoke  SelectObject,[esi].ps.hdc,eax
        invoke  DeleteObject,eax
        invoke  LineTo,[esi].ps.hdc,3,0        
    .endif
    ret

DrawChev    endp
end    